Package org.eclipse.emf.cdo.eresource

## Interface CDOResourceNode

- All Superinterfaces:
    `CDOObject`, `CDOWithID`, `org.eclipse.emf.ecore.EObject`, `org.eclipse.emf.common.notify.Notifier`
  All Known Subinterfaces:
    `CDOBinaryResource`, `CDOFileResource<IO>`, `CDOResource`, `CDOResourceFolder`, `CDOResourceLeaf`, `CDOTextResource`, `InternalCDOResource`
  All Known Implementing Classes:
    `CDOBinaryResourceImpl`, `CDOFileResourceImpl`, `CDOResourceFolderImpl`, `CDOResourceImpl`, `CDOResourceLeafImpl`, `CDOResourceNodeImpl`, `CDOTextResourceImpl`

      public interface CDOResourceNode
      extends CDOObject

  A representation of the model object 'CDO Resource Node'.
  See Also:
    `EresourcePackage.getCDOResourceNode()`
  Generated
  Extends
    CDOObject
  Model
    abstract="true"
  No Implement
    This interface is not intended to be implemented by clients.

    The following features are supported:

    - `Folder`
    - `Name`
    - `Path`
  No Extend
    This interface is not intended to be extended by clients.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ROOT_NAME` |
    `static java.lang.String` | `ROOT_PATH` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `delete​(java.util.Map<?,​?> options)` |
    `java.lang.String` | `getBasename()` |
    `java.lang.String` | `getExtension()` |
    `CDOResourceFolder` | `getFolder()` | Returns the value of the 'Folder' container reference.
    `java.lang.String` | `getName()` | Returns the value of the 'Name' attribute.
    `java.lang.String` | `getPath()` | Returns the value of the 'Path' attribute.
    `org.eclipse.emf.common.util.URI` | `getURI()` |
    `boolean` | `isRoot()` |
    `void` | `setBasename​(java.lang.String basename)` |
    `void` | `setExtension​(java.lang.String extension)` |
    `void` | `setFolder​(CDOResourceFolder value)` | Sets the value of the '`Folder`' container reference.
    `void` | `setName​(java.lang.String value)` | Sets the value of the '`Name`' attribute.
    `void` | `setPath​(java.lang.String value)` | Sets the value of the '`Path`' attribute.
    `java.lang.String` | `trimExtension()` | Same as `getBasename()`.

    - ### Methods inherited from interface org.eclipse.emf.cdo.CDOObject

      `cdoConflict, cdoDirectResource, cdoHistory, cdoID, cdoInvalid, cdoLockState, cdoPermission, cdoPrefetch, cdoReadLock, cdoReload, cdoResource, cdoRevision, cdoRevision, cdoState, cdoView, cdoWriteLock, cdoWriteOption`

    - ### Methods inherited from interface org.eclipse.emf.ecore.EObject

      `eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

    - ### Methods inherited from interface org.eclipse.emf.common.notify.Notifier

      `eAdapters, eDeliver, eNotify, eSetDeliver`

- - ### Field Detail

    - #### ROOT_PATH

          static final java.lang.String ROOT_PATH

      Since:
        2.0
      See Also:
        Constant Field Values
      Added

    - #### ROOT_NAME

          static final java.lang.String ROOT_NAME

      Since:
        2.0
      Added

  - ### Method Detail

    - #### isRoot

          boolean isRoot()

      Since:
        2.0
      Added

    - #### getFolder

          CDOResourceFolder getFolder()

      Returns the value of the 'Folder' container reference. It is bidirectional and its opposite is '`Nodes`'.

      If the meaning of the 'Folder' container reference isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Folder' container reference.
      See Also:
        `setFolder(CDOResourceFolder)`, `EresourcePackage.getCDOResourceNode_Folder()`, `CDOResourceFolder.getNodes()`
      Generated
      Model
        opposite="nodes" transient="false"

    - #### setFolder

          void setFolder​(CDOResourceFolder value)

      Sets the value of the '`Folder`' container reference.
      Parameters:
        `value` - the new value of the 'Folder' container reference.
      See Also:
        `getFolder()`
      Generated

    - #### getName

          java.lang.String getName()

      Returns the value of the 'Name' attribute.

      If the meaning of the 'Name' attribute isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Name' attribute.
      See Also:
        `setName(String)`, `EresourcePackage.getCDOResourceNode_Name()`
      Generated
      Model
        annotation="http://www.eclipse.org/CDO/DBStore columnType='VARCHAR' columnLength='255'"

    - #### setName

          void setName​(java.lang.String value)

      Sets the value of the '`Name`' attribute.
      Parameters:
        `value` - the new value of the 'Name' attribute.
      See Also:
        `getName()`
      Generated

    - #### getPath

          java.lang.String getPath()

      Returns the value of the 'Path' attribute.

      If the meaning of the 'Path' attribute isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Path' attribute.
      See Also:
        `setPath(String)`, `EresourcePackage.getCDOResourceNode_Path()`
      Generated
      Model
        transient="true" volatile="true" derived="true"

    - #### setPath

          void setPath​(java.lang.String value)

      Sets the value of the '`Path`' attribute.
      Parameters:
        `value` - the new value of the 'Path' attribute.
      See Also:
        `getPath()`
      Generated

    - #### getExtension

          java.lang.String getExtension()

      Since:
        4.4
      Added

    - #### setExtension

          void setExtension​(java.lang.String extension)

      Since:
        4.8
      Added

    - #### trimExtension

          java.lang.String trimExtension()

      Same as `getBasename()`.
      Since:
        4.4
      Added

    - #### getBasename

          java.lang.String getBasename()

      Since:
        4.8
      Added

    - #### setBasename

          void setBasename​(java.lang.String basename)

      Since:
        4.8
      Added

    - #### getURI

          org.eclipse.emf.common.util.URI getURI()

      Added

    - #### delete

          void delete​(java.util.Map<?,​?> options)
               throws java.io.IOException

      Throws:
        `java.io.IOException`
      Added